CREATE PROCEDURE [dbo].[GetPlaneDock](@TEXT VARCHAR(MAX), @DATEFROM VARCHAR(15), @DATETO VARCHAR(15), @LMROS VARCHAR(5))
AS
BEGIN
DECLARE @DOCKTABLE TABLE (DOCKCD VARCHAR(4))
DECLARE @PHYDOCK TABLE (DOCKCD VARCHAR(4))
DECLARE @FROM VARCHAR(20), @TO VARCHAR(20)
DECLARE @DOCK_MAPPING INT

--SELECT @FROM = COALESCE(@FROM + '', '') + CAST(s AS VARCHAR) FROM [dbo].fnSplitString(@DATEFROM,'/')
--SET @FROM = SUBSTRING(@FROM,5,4) + SUBSTRING(@FROM,1,2) + SUBSTRING(@FROM,3,2)

--SELECT @TO = COALESCE(@TO + '', '') + CAST(s AS VARCHAR) FROM [dbo].fnSplitString(@DATETO,'/')
--SET @TO = SUBSTRING(@TO,5,4) + SUBSTRING(@TO,1,2) + SUBSTRING(@TO,3,2)

select @FROM = cast(@DATEFROM AS DATE)
select @TO = cast(@DATETO AS DATE)


INSERT INTO @DOCKTABLE SELECT s FROM [dbo].fnSplitString(@TEXT,';')

--INSERT INTO @PHYDOCK 
--SELECT ISNULL(A.PHYSICAL_DOCKCD, B.DOCKCD) 
--FROM TB_M_PHYSICAL_DOCK_MAPPING A JOIN @DOCKTABLE B 
--ON A.LOGICAL_DOCKCD = B.DOCKCD OR A.PHYSICAL_DOCKCD = B.DOCKCD


SET @DOCK_MAPPING = (SELECT COUNT(1) FROM TB_M_PHYSICAL_DOCK_MAPPING A 
WHERE A.LOGICAL_DOCKCD = @TEXT 
OR A.PHYSICAL_DOCKCD = @TEXT);

IF (@DOCK_MAPPING > 0)
BEGIN

INSERT INTO @PHYDOCK SELECT ISNULL(A.PHYSICAL_DOCKCD,@TEXT) 
FROM TB_M_PHYSICAL_DOCK_MAPPING A 
WHERE A.LOGICAL_DOCKCD = @TEXT OR A.PHYSICAL_DOCKCD = @TEXT
--INSERT INTO @PHYDOCK SELECT DOCKCD FROM @DOCKTABLE
END

ELSE
BEGIN

INSERT INTO @PHYDOCK SELECT @TEXT
--INSERT INTO @PHYDOCK SELECT DOCKCD FROM @DOCKTABLE

END


INSERT INTO @PHYDOCK
SELECT A.LOGICAL_DOCKCD FROM TB_M_PHYSICAL_DOCK_MAPPING A JOIN @PHYDOCK B ON A.PHYSICAL_DOCKCD = B.DOCKCD

SELECT DISTINCT
A.CRCVLDCKCD [RCVDOCK]
FROM TB_R_PLANE A
INNER JOIN TB_M_SUPPLIER B ON B.SUPPLIER_CODE = RIGHT(REPLICATE('0',4) + CAST(A.CSUPLLOGPTCD AS VARCHAR(4)),4) 
AND B.SUPPLIER_PLANT_CD = A.CSUPLPLNTCD
WHERE CRCVLDCKCD IN (SELECT DISTINCT DOCKCD FROM @PHYDOCK) 
--AND DORDDATE >= @FROM AND DORDDATE <= @TO 
--AND DORDDATE IN (@FROM, @TO) 
AND CAST(DORDDATE AS DATE) IN (@FROM, @TO)
AND LMROS = @LMROS
ORDER BY  RCVDOCK ASC
END

